// IFELanguageDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IFELanguage.h"
#include "IFELanguageDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// _countof is new (VC 2005)
#ifndef _countof
#define	_countof(a)	(sizeof(a)/sizeof(a[0]))
#endif

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CIFELanguageDlg dialog

typedef struct ID2Flag {
	int		nDlgItemID;
	DWORD	dwFlag;
} ID2FLAG;

ID2FLAG	CModes[] = {
	{ IDC_CHK_FELANG_CMODE_MONORUBY,        FELANG_CMODE_MONORUBY },
	{ IDC_CHK_FELANG_CMODE_NOPRUNING,       FELANG_CMODE_NOPRUNING },
	{ IDC_CHK_FELANG_CMODE_KATAKANAOUT,     FELANG_CMODE_KATAKANAOUT },
	{ IDC_CHK_FELANG_CMODE_HIRAGANAOUT,     FELANG_CMODE_HIRAGANAOUT },
	{ IDC_CHK_FELANG_CMODE_HALFWIDTHOUT,    FELANG_CMODE_HALFWIDTHOUT },
	{ IDC_CHK_FELANG_CMODE_FULLWIDTHOUT,    FELANG_CMODE_FULLWIDTHOUT },
	{ IDC_CHK_FELANG_CMODE_BOPOMOFO,        FELANG_CMODE_BOPOMOFO },
	{ IDC_CHK_FELANG_CMODE_HANGUL,          FELANG_CMODE_HANGUL },
	{ IDC_CHK_FELANG_CMODE_PINYIN,          FELANG_CMODE_PINYIN },
	{ IDC_CHK_FELANG_CMODE_PRECONV,         FELANG_CMODE_PRECONV },
	{ IDC_CHK_FELANG_CMODE_RADICAL,         FELANG_CMODE_RADICAL },
	{ IDC_CHK_FELANG_CMODE_UNKNOWNREADING,  FELANG_CMODE_UNKNOWNREADING },
	{ IDC_CHK_FELANG_CMODE_MERGECAND,       FELANG_CMODE_MERGECAND },
	{ IDC_CHK_FELANG_CMODE_ROMAN,           FELANG_CMODE_ROMAN },
	{ IDC_CHK_FELANG_CMODE_BESTFIRST,       FELANG_CMODE_BESTFIRST },
	{ IDC_CHK_FELANG_CMODE_USENOREVWORDS,   FELANG_CMODE_USENOREVWORDS },
	{ IDC_CHK_FELANG_CMODE_NONE,            FELANG_CMODE_NONE },
	{ IDC_CHK_FELANG_CMODE_PLAURALCLAUSE,   FELANG_CMODE_PLAURALCLAUSE },
	{ IDC_CHK_FELANG_CMODE_SINGLECONVERT,   FELANG_CMODE_SINGLECONVERT },
	{ IDC_CHK_FELANG_CMODE_AUTOMATIC,       FELANG_CMODE_AUTOMATIC },
	{ IDC_CHK_FELANG_CMODE_PHRASEPREDICT,   FELANG_CMODE_PHRASEPREDICT },
	{ IDC_CHK_FELANG_CMODE_CONVERSATION,    FELANG_CMODE_CONVERSATION },
	{ IDC_CHK_FELANG_CMODE_NAME,            FELANG_CMODE_NAME },
	{ IDC_CHK_FELANG_CMODE_NOINVISIBLECHAR, FELANG_CMODE_NOINVISIBLECHAR }
};

ID2FLAG	CRequests[] = {
	{ IDC_RDB_FELANG_REQ_CONV,   FELANG_REQ_CONV },
	{ IDC_RDB_FELANG_REQ_RECONV, FELANG_REQ_RECONV },
	{ IDC_RDB_FELANG_REQ_REV,    FELANG_REQ_REV }
};

CIFELanguageDlg::CIFELanguageDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIFELanguageDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CIFELanguageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDT_OUTPUT, m_Output);
}

BEGIN_MESSAGE_MAP(CIFELanguageDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_ACTION, &CIFELanguageDlg::OnBnClickedAction)
	ON_BN_CLICKED(IDC_RDB_MSIME_CHINA, &CIFELanguageDlg::OnMsimeChanged)
	ON_BN_CLICKED(IDC_RDB_MSIME_JAPAN, &CIFELanguageDlg::OnMsimeChanged)
	ON_BN_CLICKED(IDC_RDB_MSIME_TAIWAN, &CIFELanguageDlg::OnMsimeChanged)
	ON_BN_CLICKED(IDC_RDB_MSIME_TAIWAN_IMEBBO, &CIFELanguageDlg::OnMsimeChanged)
END_MESSAGE_MAP()


// CIFELanguageDlg message handlers

BOOL CIFELanguageDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	CheckRadioButton( IDC_RDB_FELANG_REQ_CONV, IDC_RDB_FELANG_REQ_REV, IDC_RDB_FELANG_REQ_REV );
	CheckRadioButton( IDC_RDB_MSIME_CHINA, IDC_RDB_MSIME_TAIWAN_IMEBBO, IDC_RDB_MSIME_JAPAN );
	OnMsimeChanged();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CIFELanguageDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CIFELanguageDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CIFELanguageDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CIFELanguageDlg::OnBnClickedAction()
{
	DWORD	dwCMode = 0;
	for( int i = 0; i < _countof(CModes); i++ )
		if( IsDlgButtonChecked( CModes[i].nDlgItemID ) )
			dwCMode |= CModes[i].dwFlag;

	DWORD dwRequest = GetCheckedRadioButton( IDC_RDB_FELANG_REQ_CONV, IDC_RDB_FELANG_REQ_REV );
	for( int i = 0; i < _countof(CRequests); i++ )
		if( dwRequest == CRequests[i].nDlgItemID )
			dwRequest = CRequests[i].dwFlag;

	CStringW	inString;
	GetDlgItemText( IDC_EDT_INPUT, inString );

	int i;
	SetDlgItemText( IDC_EDT_OUTPUT, _T("") );
	if( m_engine.GetJMorphResult( dwRequest, dwCMode, (LPCTSTR)inString ) == S_OK )
		if( m_engine.m_pmorrslt ) {
			CStringW	tmpString1, tmpString2;

			tmpString1 = m_engine.m_pmorrslt->pwchOutput;
			tmpString1.Delete(m_engine.m_pmorrslt->cchOutput,tmpString1.GetLength());
			m_Output.SetWindowText( _T("") );
			tmpString2.Format( L"pwchOutput: %s\r\n", tmpString1 );
			AppendToOutput( tmpString2 );

			tmpString1 = m_engine.m_pmorrslt->pwchRead;
			tmpString1.Delete(m_engine.m_pmorrslt->cchRead,tmpString1.GetLength());
			tmpString2.Format( L"pwchRead: %s\r\n", tmpString1 );
			AppendToOutput( tmpString2 );

			AppendToOutput( _T("pchInputPos: ") );
			for( i = 0; i < inString.GetLength(); i++  ) {
				tmpString2.Format( L"%x ", m_engine.m_pmorrslt->pchInputPos[i] );
				AppendToOutput( tmpString2 );
			}
			AppendToOutput( L"\r\n" );

			AppendToOutput( _T("pchOutputIdxWDD: ") );
			for( i = 0; i < m_engine.m_pmorrslt->cchOutput; i++  ) {
				tmpString2.Format( L"%x ", m_engine.m_pmorrslt->pchOutputIdxWDD[i] );
				AppendToOutput( tmpString2 );
			}
			AppendToOutput( L"\r\n" );

			AppendToOutput( _T("pchReadIdxWDD: ") );
			for( i = 0; i < m_engine.m_pmorrslt->cchRead; i++  ) {
				tmpString2.Format( L"%x ", m_engine.m_pmorrslt->pchReadIdxWDD[i] );
				AppendToOutput( tmpString2 );
			}
			AppendToOutput( L"\r\n" );
//WORD *paMonoRubyPos;

			tmpString2.Format( _T("pWDD [%d] = {\r\n"), m_engine.m_pmorrslt->cWDD );
			AppendToOutput( tmpString2 );
			for( i = 0; i < m_engine.m_pmorrslt->cWDD; i++  ) {
				tmpString2.Format(
					L"    { "
					L" wDispPos=%d,"
					L" wReadPos=%d,"
					L" cchDisp=%d,"
					L" cchRead=%d,"
					L" nReserve=%d,"
					L" nPos=%d,\r\n"
					L"        fPhrase:%d,"
					L" fAutoCorrect:%d,"
					L" fNumericPrefix:%d,"
					L" fUserRegistered:%d,"
					L" fUnknown:%d,"
					L" fRecentUsed:%d,\r\n"
					L"        pReserved=0x%x\r\n"
					L"    }\r\n",
					m_engine.m_pmorrslt->pWDD[i].wDispPos,
					m_engine.m_pmorrslt->pWDD[i].wReadPos,
					m_engine.m_pmorrslt->pWDD[i].cchDisp,
					m_engine.m_pmorrslt->pWDD[i].cchRead,
					m_engine.m_pmorrslt->pWDD[i].nReserve,
					m_engine.m_pmorrslt->pWDD[i].nPos,
					m_engine.m_pmorrslt->pWDD[i].fPhrase,
					m_engine.m_pmorrslt->pWDD[i].fAutoCorrect,
					m_engine.m_pmorrslt->pWDD[i].fNumericPrefix,
					m_engine.m_pmorrslt->pWDD[i].fUserRegistered,
					m_engine.m_pmorrslt->pWDD[i].fUnknown,
					m_engine.m_pmorrslt->pWDD[i].fRecentUsed,
					m_engine.m_pmorrslt->pWDD[i].pReserved );
				AppendToOutput( tmpString2 );
			}
			AppendToOutput( L"};\r\n" );
		}
}

void CIFELanguageDlg::OnMsimeChanged()
{
	DWORD dwRadio = GetCheckedRadioButton( IDC_RDB_MSIME_CHINA, IDC_RDB_MSIME_TAIWAN_IMEBBO );
	switch( dwRadio ) {
		case IDC_RDB_MSIME_CHINA:
			m_engine.SetIMEEngine( L"MSIME.China" );
			break;
		case IDC_RDB_MSIME_JAPAN:
			m_engine.SetIMEEngine( L"MSIME.Japan" );
			break;
		case IDC_RDB_MSIME_TAIWAN:
			m_engine.SetIMEEngine( L"MSIME.Taiwan" );
			break;
		case IDC_RDB_MSIME_TAIWAN_IMEBBO:
			m_engine.SetIMEEngine( L"MSIME.Taiwan.ImeBbo" );
			break;
	}

	BOOL bEnable;
	if( m_engine.IsReady() ) {
		CWnd *pDlgID;
		for( int i = 0; i < _countof(CModes); i++ ) {
			bEnable = CModes[i].dwFlag & m_engine.m_dwCaps;
			// FELANG_CMODE_HIRAGANAOUT == 0, so & does not work
			// We assume that ime supports FELANG_CMODE_HIRAGANAOUT if it supports FELANG_CMODE_KATAKANAOUT
			if( CModes[i].dwFlag == FELANG_CMODE_HIRAGANAOUT )
				if( FELANG_CMODE_KATAKANAOUT & m_engine.m_dwCaps )
					bEnable = TRUE;

			pDlgID = GetDlgItem(CModes[i].nDlgItemID);
			if( pDlgID )
				pDlgID->EnableWindow( bEnable );
			if( !bEnable )
				CheckDlgButton( CModes[i].nDlgItemID, FALSE );
		}
	}
}

void CIFELanguageDlg::AppendToOutput( LPCTSTR str )
{
	m_Output.SetSel( -1, -1, 0 );
	m_Output.ReplaceSel( str );
}
